ASMB,A,B,L
*
* Overlay for BASIC 20392 running on HP21MX with HP-IPL/OS
* Original 11/29/10 Last mod 12/4/10
*
* CALL(1)               EXIT - jumps to 77000 to exit, restarting HP-IPL/OS
* CALL(2)               WEXIT - adds code to 77100 to "return" from BASIC
* CALL(3,address,data)  POKE - put data into address
* CALL(4,address,var)   PEEK - put data from address into var
* CALL(5,address)       EXEC - execute subroutine at address and return
* CALL(6,address)       JUMP - execute code at address, don't return
* CALL(7,var)           GETCH - set var to next byte from console
* CALL(8,byte)          PUTCH - send byte to console
*
* Installation...
* Load BASIC (attach to PTR then ALTSAVE ZAM ABSLOAD)
* Load this overlay on top of it (attach to PTR then ABSLOAD)
* Run BASIC from location 100 (ALTRUN)
* Exit BASIC and save binary (BYE then AM2ABS or other means)
* Note... this code (~72000-72377) must also be saved with binary
*
       ORG 121B
       DEF LINKS
       DEF LKEND
       ORG 72000B
       HLT 1            wild execution barrior
       JMP *-1          don't allow continue
*
* link table...
LINKS  OCT 1            call 1 no parms
       DEF EXIT         normal swap exit
       OCT 2            call 2 no parms
       DEF WEXIT        exit to next word
       OCT 1003         call 3 two parms
       DEF POKE         poke memory
       OCT 1004         call 4 two parms
       DEF PEEK         peek memory
       OCT 405          call 5 one parm
       DEF EXEC         execute subroutine
       OCT 406          call 6 one parm
       DEF JUMP         jump to code
       OCT 407          call 7 one parm
       DEF GETCH        get char from console
       OCT 410          call 8 one parm
       DEF PUTCH        send char to console
LKEND  EQU *
*
* 21MX FP subs - this package is designed for running from
* HP-IPL/OS with DMS enabled, assuming the machine has FP
* If not then replace DOFLT and DOFIX with FP convert code
* and don't use the exit calls (1 and 2).
*
* Convert 16 bit int in A to FP in A/B
DOFLT  NOP
       OCT 105120
       JMP DOFLT,I
*
* Convert FP in A/B to 16 bit int in A
* note - no error check, GIGO
DOFIX  NOP
       OCT 105100
       JMP DOFIX,I
*
* Return code... swap main/alt (2-76001) then JMP 321,I
* copy to 77100 then execute, mem from 76400-76777 used for buffer
*                       ORG 77100B
RCODE  OCT 105734       OCT 105734          * SJP
       OCT 077102       DEF *+1             * just enable system map
       OCT 063131       LDA C2
       OCT 073135       STA CADR            * start at address 2
       OCT 105745  LOOP OCT 105745          * LDX
       OCT 077134       DEF BSIZ            * number of words, 400 octal
       OCT 063135       LDA CADR            * source address
       OCT 067133       LDB BUFF            * destination address = 76400 in alt
       OCT 105705       OCT 105705          * MWI move words into alt
       OCT 105745       OCT 105745          * LDX
       OCT 077134       DEF BSIZ            * buffer size
       OCT 063135       LDA CADR            * current address in alt
       OCT 067135       LDB CADR            * current address in sys
       OCT 105706       OCT 105706          * MWF move words from alt map
       OCT 105745       OCT 105745          * LDX
       OCT 077134       DEF BSIZ            * buffer size
       OCT 063133       LDA BUFF            * source = buffer in alt
       OCT 067135       LDB CADR            * dest = currentaddr in alt
       OCT 105707       OCT 105707          * MWW move words within alt map
       OCT 063135       LDA CADR
       OCT 043134       ADA BSIZ            * add 400 oct to current address
       OCT 053132       CPA ENDA            * if at end
       OCT 124321       JMP 321B,I          * run HP-IPL/OS next code
       OCT 073135       STA CADR
       OCT 027104       JMP LOOP
       OCT 000002  C2   OCT 2
       OCT 076002  ENDA OCT 76002           * terminate address
       OCT 076400  BUFF OCT 76400           * buffer at 76400-76777
       OCT 000400  BSIZ OCT 400             * buffer size 256 words
*                  CADR OCT 0               * current address
RCLST  EQU *
*
* jump to 77000 to exit, stock swapper assumed to exist
EXIT   NOP
       JMP *+1,I
       OCT 77000
*
* word exit - copy return code to 77100 then jump to it
WEXIT  NOP
       LDA RCBEG
       STA RCPTR
       LDB RDEST
WLOOP  LDA RCPTR,I
       STA 1,I
       ISZ RCPTR
       INB
       LDA RCPTR
       CPA RCEND
       JMP RDEST,I
       JMP WLOOP
RCBEG  DEF RCODE
RCEND  DEF RCLST
RDEST  OCT 77100
RCPTR  OCT 0
*
* parm temps
PAR1A  OCT 0     address
PAR1B  OCT 0     float 1
PAR1C  OCT 0     float 2
PAR1I  OCT 0     int value
PAR2A  OCT 0
PAR2B  OCT 0
PAR2C  OCT 0
PAR2I  OCT 0
M1     DEC -1    for decrementing
*
* parm subs
GET2P  NOP
       LDB 0,I         get address of first parm
       STB PAR1A       save address
       ADA M1          dec ptr
       LDB 0,I         get address of second parm
       STB PAR2A       save
       JSB PTRAN       fetch FP values and convert to int
       JMP GET2P,I
GET1P  NOP
       LDB 0,I         get address of first parm
       STB PAR1A       save address
       JSB PTRAN
       JMP GET1P,I
PTRAN  NOP
       LDA PAR1A       get address of parm 1
       LDB 0,I         get 1st FP word
       STB PAR1B       save
       INA             point to next FP word
       LDB 0,I         get 2nd FP word
       STB PAR1C       save
       LDA PAR2A       same for parm 2 (even if not used)
       LDB 0,I
       STB PAR2B
       INA
       LDB 0,I
       STB PAR2C
* convert parms to int
       LDA PAR1B       get parm 1 fp 1
       LDB PAR1C       get parm 1 fp 2
       JSB DOFIX       convert to fixed
       STA PAR1I       save in parm 1 int
       LDA PAR2B       same for parm 2
       LDB PAR2C
       JSB DOFIX
       STA PAR2I
       JMP PTRAN,I
*
* update parm 1 with int in A
* overwrites PARM1B/C PARM1I not affected
UPDP1  NOP
       JSB DOFLT       convert to float
       STA PAR1B       save fp 1
       STB PAR1C       save fp 2
       LDB PAR1A       get parm address
       LDA PAR1B       get fp 1
       STA 1,I         save to parm var
       INB             bump pointer
       LDA PAR1C       get fp 2
       STA 1,I         save to parm var+1
       JMP UPDP1,I
*
* update parm 2 with int in A
* overwrites PARM2B/C PARM2I not affected
UPDP2  NOP
       JSB DOFLT
       STA PAR2B
       STB PAR2C
       LDB PAR2A
       LDA PAR2B
       STA 1,I
       INB
       LDA PAR2C
       STA 1,I
       JMP UPDP2,I
*
* put 2nd parm into address spec'd by 1st parm
POKE   NOP
       JSB GET2P      get 2 parms convert to int
       LDA PAR2I     get data
       STA PAR1I,I   store in address
       JMP POKE,I
*
* put data from address spec'd by 1st parm and put into 2nd parm
PEEK   NOP
       JSB GET2P
       LDA PAR1I,I   get memory data
       JSB UPDP2      update 2nd parm
       JMP PEEK,I
*
* execute subroutine at address spec'd by parm
EXEC   NOP
       JSB GET1P
       JSB PAR1I,I
       JMP EXEC,I
*
* jump to address spec'd by parm (no return)
JUMP   NOP
       JSB GET1P
       JMP PAR1I,I
*
* Direct access non-interrupt console drivers
* These bypass the normal TTY driver, slot is fetched from
* the driver which is assumed to be a Rev A or Rev B version
* (no patch occurs if it is not).
*
* The BASIC TTY driver config is a bit hard to parse... the
* prepare program (and even the driver itself) rewrites the code.
* The self-patch code here patches only if it finds the right
* instruction, otherwise goes with what it has. TTYOS and TTYIS
* can be modified if needed to adjust for different config.
*
TTY    EQU 11B           default TTY slot
TTYOS  OCT 11            offset for driver instruction
TTYIS  OCT 102600        instruction that's supposed to be there
SLTCL  OCT 177700        mask to clear slot
SLTGT  OCT 77            mask to get slot
TTYIN  OCT 160000        TTY input command
TTYOT  OCT 120000        TTY output command
MASKC  OCT 177           mask for 7 bits
PSLOT  OCT 0             patch slot
*
* patch TTY slot, disable interrupts
CONIO  NOP
       CLA
       STA PSLOT         clear slot to determine if patch occured
       LDA 102B          get TTY driver link
       ADA TTYOS         add TTY instruction offset
       STA 1             put in B reg
       LDA 1,I           get instruction
       AND SLTCL         mask off slot
       CPA TTYIS         is it the instruction we're looking for?
       RSS               yes, skip to do patch
       JMP NOPAT         no, don't patch
       LDA 1,I           get instruction
       AND SLTGT         get slot
       STA PSLOT         save
       LDB PLIST         put start of patchlist in B
       JSB PATCH         do the patch
NOPAT  CLF 0             disable interrupts
       JMP CONIO,I
*
* patch sub - patch list address in B
PATCH  NOP
PATLP  LDA 1,I           get instruction address to patch
       STA ADTMP         save
       LDA ADTMP,I       get instruction to patch
       AND SLTCL         mask off slot
       IOR PSLOT         set to new slot
       STA ADTMP,I       store patched instruction
       INB               increment patchlist pointer
       LDA 1,I           check next patch address
       SZA               skip if zero
       JMP PATLP         patch some more
       JMP PATCH,I
ADTMP  OCT 0
*
* list of locations to patch
PLIST  DEF *+1
       DEF TTYP1
       DEF TTYP2
       DEF TTYP3
       DEF TTYP4
       DEF TTYP5
       DEF TTYP6
       DEF TTYP7
       DEF TTYP8
       DEF TTYP9
       DEF TTYPA
       OCT 0
*
* get byte from console and put in parm
GETCH  NOP
       JSB GET1P         parse parm to set address
       JSB CONIO         set up for non-int I/O
       LDA TTYIN         get TTY input command
TTYP1  OTA TTY           send to interface
TTYP2  STC TTY,C         start interface
TTYP3  SFS TTY           got char?
       JMP *-1           no, keep looping
TTYP4  LIA TTY           get char
TTYP5  CLC TTY           turn off interface
       AND MASKC         mask char
       JSB UPDP1         update parm
       STF 0             reenable interrupts
       JMP GETCH,I
*
* send byte in parm to console
PUTCH  NOP
       JSB GET1P         get parm
       JSB CONIO         set up for non-int I/O
       LDA TTYOT         get TTY output command
TTYP6  OTA TTY           send to interface
       LDA PAR1I         get byte to send
       AND MASKC         mask char
TTYP7  OTA TTY           send char to interface
TTYP8  STC TTY,C         start interface
TTYP9  SFS TTY           accepted?
       JMP *-1           no, keep looping
TTYPA  CLC TTY           turn off interface
       STF 0             reenable interrupts
       JMP PUTCH,I
*
       END
